;.include "table_8.inc"

.data

.p2align 2
work_time:
  .space 4, 0

.p2align 2
result_buffer:
  .space 128, 0
  
.text

.alias value1   0
.alias value2   1
.alias value3   2
.alias value4   3
.alias value5   4
.alias value6   5
.alias value7   6
.alias value8   7

.alias itr_result ST1PRDR
.alias result     ST2PRDR
.alias counter    ST3PRDR

set_psw_rw:
  jmp init
  getl #PSW
  orl @1, 0x40
  setl #PSW, @1
complete

init:
           jmp start_timer
           setl #itr_result, 0x0
           setl #result, 0x0
           
  b1    := getb 0x0
  b2    := getb @b1 + 1
  b3    := getb @b1 + 2
  b4    := getb @b1 + 3
  b5    := getb @b1 + 4
  b6    := getb @b1 + 5
  b7    := getb @b1 + 6
  b8    := getb @b1 + 7
  
  s2    := slll @b2, 8
  s3    := slll @b3, 16
  s4    := slll @b4, 24 
  s6    := slll @b6, 8
  s7    := slll @b7, 16
  s8    := slll @b8, 24
  
  v1    := andl @b1, 0x000000FF
  v2    := andl @s2, 0x0000FF00
  v3    := andl @s3, 0x00FF0000
  v4    := andl @s4, 0xFF000000 
  v5    := andl @b5, 0x000000FF 
  v6    := andl @s6, 0x0000FF00
  v7    := andl @s7, 0x00FF0000
  v8    := andl @s8, 0xFF000000
  
  r1_16 := orl @v1, @v2
  r2_16 := orl @v3, @v4
  r3_16 := orl @v5, @v6
  r4_16 := orl @v7, @v8
  
  r1_32 := orl @r1_16, @r2_16
  r2_32 := orl @r3_16, @r4_16
  
  r64   := patch @r1_32, @r2_32
  
           setq #value1, @r64     
           setq #value2, @r64
           setq #value3, @r64
           setq #value4, @r64
           setq #value5, @r64
           setq #value6, @r64
           setq #value7, @r64
           setq #value8, @r64
complete

start_timer:
  jmp new_popcnt512_reg
  setl #ST0PRDR, 0xFFFFFFFF
  setl #ST0CR, 0x1
complete

new_popcnt512_reg:
  getl #counter
  getl 0
  incr     :=  addl @2, 16
  con      :=  subl @3, @2

  val1_64  := getq #value1
  val2_64  := getq #value2
  val3_64  := getq #value3
  val4_64  := getq #value4  
  
  val5_64  := getq #value5
  val6_64  := getq #value6
  val7_64  := getq #value7
  val8_64  := getq #value8
  
  val1     := getl #value1
  val2     := getl #value2
  val3     := getl #value3
  val4     := getl #value4
  
  val5     := getl #value5
  val6     := getl #value6
  val7     := getl #value7
  val8     := getl #value8
  
              je @con, stop_timer
              jne @con, new_popcnt512_reg
              setl #counter, @incr
  
  val9     := slrq @val1_64, 32
  val10    := slrq @val2_64, 32
  val11    := slrq @val3_64, 32
  val12    := slrq @val4_64, 32
  
  val13    := slrq @val5_64, 32
  val14    := slrq @val6_64, 32
  val15    := slrq @val7_64, 32 
  val16    := slrq @val8_64, 32
  
  s1_1     := slrl @val1,  1
  s1_2     := slrl @val2,  1
  s1_3     := slrl @val3,  1
  s1_4     := slrl @val4,  1
   
  s1_5     := slrl @val5,  1 
  s1_6     := slrl @val6,  1 
  s1_7     := slrl @val7,  1 
  s1_8     := slrl @val8,  1
  
  s1_9     := slrl @val9,  1
  s1_10    := slrl @val10, 1
  s1_11    := slrl @val11, 1
  s1_12    := slrl @val12, 1
  
  s1_13    := slrl @val13, 1 
  s1_14    := slrl @val14, 1
  s1_15    := slrl @val15, 1
  s1_16    := slrl @val16, 1
  
  s2_1     := andl @s1_1,  0x55555555
  s2_2     := andl @s1_2,  0x55555555
  s2_3     := andl @s1_3,  0x55555555
  s2_4     := andl @s1_4,  0x55555555
  
  s2_5     := andl @s1_5,  0x55555555
  s2_6     := andl @s1_6,  0x55555555
  s2_7     := andl @s1_7,  0x55555555
  s2_8     := andl @s1_8,  0x55555555
  
  s2_9     := andl @s1_9,  0x55555555 
  s2_10    := andl @s1_10, 0x55555555
  s2_11    := andl @s1_11, 0x55555555 
  s2_12    := andl @s1_12, 0x55555555
   
  s2_13    := andl @s1_13, 0x55555555 
  s2_14    := andl @s1_14, 0x55555555
  s2_15    := andl @s1_15, 0x55555555
  s2_16    := andl @s1_16, 0x55555555
  
  s3_1     := subl @val1,  @s2_1
  s3_2     := subl @val2,  @s2_2
  s3_3     := subl @val3,  @s2_3
  s3_4     := subl @val4,  @s2_4
  
  s3_5     := subl @val5,  @s2_5
  s3_6     := subl @val6,  @s2_6
  s3_7     := subl @val7,  @s2_7
  s3_8     := subl @val8,  @s2_8
  
  s3_9     := subl @val9,  @s2_9
  s3_10    := subl @val10, @s2_10
  s3_11    := subl @val11, @s2_11
  s3_12    := subl @val12, @s2_12
  
  s3_13    := subl @val13, @s2_13
  s3_14    := subl @val14, @s2_14
  s3_15    := subl @val15, @s2_15
  s3_16    := subl @val16, @s2_16
  
  s4_1     := andl @s3_1,  0x33333333
  s4_2     := andl @s3_2,  0x33333333
  s4_3     := andl @s3_3,  0x33333333
  s4_4     := andl @s3_4,  0x33333333
   
  s4_5     := andl @s3_5,  0x33333333
  s4_6     := andl @s3_6,  0x33333333
  s4_7     := andl @s3_7,  0x33333333
  s4_8     := andl @s3_8,  0x33333333
  
  s4_9     := andl @s3_9,  0x33333333
  s4_10    := andl @s3_10, 0x33333333
  s4_11    := andl @s3_11, 0x33333333
  s4_12    := andl @s3_12, 0x33333333
  
  s4_13    := andl @s3_13, 0x33333333
  s4_14    := andl @s3_14, 0x33333333
  s4_15    := andl @s3_15, 0x33333333
  s4_16    := andl @s3_16, 0x33333333  
 
  s5_1     := slrl @s3_1,  2
  s5_2     := slrl @s3_2,  2
  s5_3     := slrl @s3_3,  2
  s5_4     := slrl @s3_4,  2
  
  s5_5     := slrl @s3_5,  2
  s5_6     := slrl @s3_6,  2
  s5_7     := slrl @s3_7,  2
  s5_8     := slrl @s3_8,  2
  
  s5_9     := slrl @s3_9,  2
  s5_10    := slrl @s3_10, 2
  s5_11    := slrl @s3_11, 2
  s5_12    := slrl @s3_12, 2
  
  s5_13    := slrl @s3_13, 2
  s5_14    := slrl @s3_14, 2
  s5_15    := slrl @s3_15, 2
  s5_16    := slrl @s3_16, 2
  
  s6_1     := andl @s5_1,  0x33333333
  s6_2     := andl @s5_2,  0x33333333
  s6_3     := andl @s5_3,  0x33333333
  s6_4     := andl @s5_4,  0x33333333
  
  s6_5     := andl @s5_5,  0x33333333
  s6_6     := andl @s5_6,  0x33333333
  s6_7     := andl @s5_7,  0x33333333
  s6_8     := andl @s5_8,  0x33333333
  
  s6_9     := andl @s5_9,  0x33333333
  s6_10    := andl @s5_10, 0x33333333
  s6_11    := andl @s5_11, 0x33333333
  s6_12    := andl @s5_12, 0x33333333
  
  s6_13    := andl @s5_13, 0x33333333
  s6_14    := andl @s5_14, 0x33333333
  s6_15    := andl @s5_15, 0x33333333
  s6_16    := andl @s5_16, 0x33333333 
  
  s7_1     := addl @s4_1,  @s6_1
  s7_2     := addl @s4_2,  @s6_2
  s7_3     := addl @s4_3,  @s6_3
  s7_4     := addl @s4_4,  @s6_4
  
  s7_5     := addl @s4_5,  @s6_5
  s7_6     := addl @s4_6,  @s6_6
  s7_7     := addl @s4_7,  @s6_7
  s7_8     := addl @s4_8,  @s6_8
  
  s7_9     := addl @s4_9,  @s6_9
  s7_10    := addl @s4_10, @s6_10
  s7_11    := addl @s4_11, @s6_11
  s7_12    := addl @s4_12, @s6_12
  
  s7_13    := addl @s4_13, @s6_13
  s7_14    := addl @s4_14, @s6_14
  s7_15    := addl @s4_15, @s6_15
  s7_16    := addl @s4_16, @s6_16
  
  s8_1     := slrl @s7_1,  4
  s8_2     := slrl @s7_2,  4
  s8_3     := slrl @s7_3,  4
  s8_4     := slrl @s7_4,  4
  
  s8_5     := slrl @s7_5,  4
  s8_6     := slrl @s7_6,  4
  s8_7     := slrl @s7_7,  4
  s8_8     := slrl @s7_8,  4
  
  s8_9     := slrl @s7_9,  4
  s8_10    := slrl @s7_10, 4
  s8_11    := slrl @s7_11, 4
  s8_12    := slrl @s7_12, 4
  
  s8_13    := slrl @s7_13, 4
  s8_14    := slrl @s7_14, 4
  s8_15    := slrl @s7_15, 4
  s8_16    := slrl @s7_16, 4
  
  s9_1     := addl @s7_1,  @s8_1
  s9_2     := addl @s7_2,  @s8_2
  s9_3     := addl @s7_3,  @s8_3
  s9_4     := addl @s7_4,  @s8_4
  
  s9_5     := addl @s7_5,  @s8_5
  s9_6     := addl @s7_6,  @s8_6
  s9_7     := addl @s7_7,  @s8_7
  s9_8     := addl @s7_8,  @s8_8
  
  s9_9     := addl @s7_9,  @s8_9
  s9_10    := addl @s7_10, @s8_10
  s9_11    := addl @s7_11, @s8_11
  s9_12    := addl @s7_12, @s8_12
  
  s9_13    := addl @s7_13, @s8_13
  s9_14    := addl @s7_14, @s8_14
  s9_15    := addl @s7_15, @s8_15
  s9_16    := addl @s7_16, @s8_16
  
  s10_1    := andl @s9_1,  0xF0F0F0F
  s10_2    := andl @s9_2,  0xF0F0F0F
  s10_3    := andl @s9_3,  0xF0F0F0F
  s10_4    := andl @s9_4,  0xF0F0F0F
  
  s10_5    := andl @s9_5,  0xF0F0F0F
  s10_6    := andl @s9_6,  0xF0F0F0F
  s10_7    := andl @s9_7,  0xF0F0F0F
  s10_8    := andl @s9_8,  0xF0F0F0F
  
  s10_9    := andl @s9_9,  0xF0F0F0F
  s10_10   := andl @s9_10, 0xF0F0F0F
  s10_11   := andl @s9_11, 0xF0F0F0F
  s10_12   := andl @s9_12, 0xF0F0F0F
 
  s10_13   := andl @s9_13, 0xF0F0F0F
  s10_14   := andl @s9_14, 0xF0F0F0F
  s10_15   := andl @s9_15, 0xF0F0F0F
  s10_16   := andl @s9_16, 0xF0F0F0F
 
  s11_1    := mull @s10_1,  0x1010101
  s11_2    := mull @s10_2,  0x1010101
  s11_3    := mull @s10_3,  0x1010101
  s11_4    := mull @s10_4,  0x1010101
  
  s11_5    := mull @s10_5,  0x1010101
  s11_6    := mull @s10_6,  0x1010101
  s11_7    := mull @s10_7,  0x1010101
  s11_8    := mull @s10_8,  0x1010101
  
  s11_9    := mull @s10_9,  0x1010101
  s11_10   := mull @s10_10, 0x1010101
  s11_11   := mull @s10_11, 0x1010101
  s11_12   := mull @s10_12, 0x1010101
  
  s11_13   := mull @s10_13, 0x1010101
  s11_14   := mull @s10_14, 0x1010101
  s11_15   := mull @s10_15, 0x1010101
  s11_16   := mull @s10_16, 0x1010101
  
  s12_1    := slrl @s11_1,  24
  s12_2    := slrl @s11_2,  24
  s12_3    := slrl @s11_3,  24
  s12_4    := slrl @s11_4,  24
  
  s12_5    := slrl @s11_5,  24  
  s12_6    := slrl @s11_6,  24
  s12_7    := slrl @s11_7,  24
  s12_8    := slrl @s11_8,  24
  
  s12_9    := slrl @s11_9,  24
  s12_10   := slrl @s11_10, 24
  s12_11   := slrl @s11_11, 24
  s12_12   := slrl @s11_12, 24
  
  s12_13   := slrl @s11_13, 24
  s12_14   := slrl @s11_14, 24
  s12_15   := slrl @s11_15, 24
  s12_16   := slrl @s11_16, 24
  
  sum1     := addl @s12_1,  @s12_2
  sum2     := addl @s12_3,  @s12_4
  sum3     := addl @s12_5,  @s12_6
  sum4     := addl @s12_7,  @s12_8
  
  sum5     := addl @s12_9,  @s12_10
  sum6     := addl @s12_11, @s12_12
  sum7     := addl @s12_13, @s12_14
  sum8     := addl @s12_15, @s12_16 
  
  sum9     := addl @sum1,  @sum2
  sum10    := addl @sum3,  @sum4
  sum11    := addl @sum5,  @sum6
  sum12    := addl @sum7,  @sum8
  
  sum13    := addl @sum9,  @sum10
  sum14    := addl @sum11, @sum12
  sum15    := addl @sum13, @sum14
  
              setl #itr_result, @sum15
             ; jmp check_counter_reg  
complete

new_popcnt512_mem:
  val1_64  := getq #value1
  val2_64  := getq #value2
  val3_64  := getq #value3
  val4_64  := getq #value4  
  
  val5_64  := getq #value5
  val6_64  := getq #value6
  val7_64  := getq #value7
  val8_64  := getq #value8
  
  val1     := getl #value1
  val2     := getl #value2
  val3     := getl #value3
  val4     := getl #value4
  
  val5     := getl #value5
  val6     := getl #value6
  val7     := getl #value7
  val8     := getl #value8
  
  val9     := slrq @val1_64, 32
  val10    := slrq @val2_64, 32
  val11    := slrq @val3_64, 32
  val12    := slrq @val4_64, 32
  
  val13    := slrq @val5_64, 32
  val14    := slrq @val6_64, 32
  val15    := slrq @val7_64, 32 
  val16    := slrq @val8_64, 32
  
  s1_1     := slrl @val1,  1
  s1_2     := slrl @val2,  1
  s1_3     := slrl @val3,  1
  s1_4     := slrl @val4,  1
   
  s1_5     := slrl @val5,  1 
  s1_6     := slrl @val6,  1 
  s1_7     := slrl @val7,  1 
  s1_8     := slrl @val8,  1
  
  s1_9     := slrl @val9,  1
  s1_10    := slrl @val10, 1
  s1_11    := slrl @val11, 1
  s1_12    := slrl @val12, 1
  
  s1_13    := slrl @val13, 1 
  s1_14    := slrl @val14, 1
  s1_15    := slrl @val15, 1
  s1_16    := slrl @val16, 1
  
  s2_1     := andl @s1_1,  0x55555555
  s2_2     := andl @s1_2,  0x55555555
  s2_3     := andl @s1_3,  0x55555555
  s2_4     := andl @s1_4,  0x55555555
  
  s2_5     := andl @s1_5,  0x55555555
  s2_6     := andl @s1_6,  0x55555555
  s2_7     := andl @s1_7,  0x55555555
  s2_8     := andl @s1_8,  0x55555555
  
  s2_9     := andl @s1_9,  0x55555555 
  s2_10    := andl @s1_10, 0x55555555
  s2_11    := andl @s1_11, 0x55555555 
  s2_12    := andl @s1_12, 0x55555555
   
  s2_13    := andl @s1_13, 0x55555555 
  s2_14    := andl @s1_14, 0x55555555
  s2_15    := andl @s1_15, 0x55555555
  s2_16    := andl @s1_16, 0x55555555
  
  s3_1     := subl @val1,  @s2_1
  s3_2     := subl @val2,  @s2_2
  s3_3     := subl @val3,  @s2_3
  s3_4     := subl @val4,  @s2_4
  
  s3_5     := subl @val5,  @s2_5
  s3_6     := subl @val6,  @s2_6
  s3_7     := subl @val7,  @s2_7
  s3_8     := subl @val8,  @s2_8
  
  s3_9     := subl @val9,  @s2_9
  s3_10    := subl @val10, @s2_10
  s3_11    := subl @val11, @s2_11
  s3_12    := subl @val12, @s2_12
  
  s3_13    := subl @val13, @s2_13
  s3_14    := subl @val14, @s2_14
  s3_15    := subl @val15, @s2_15
  s3_16    := subl @val16, @s2_16
  
  s4_1     := andl @s3_1,  0x33333333
  s4_2     := andl @s3_2,  0x33333333
  s4_3     := andl @s3_3,  0x33333333
  s4_4     := andl @s3_4,  0x33333333
   
  s4_5     := andl @s3_5,  0x33333333
  s4_6     := andl @s3_6,  0x33333333
  s4_7     := andl @s3_7,  0x33333333
  s4_8     := andl @s3_8,  0x33333333
  
  s4_9     := andl @s3_9,  0x33333333
  s4_10    := andl @s3_10, 0x33333333
  s4_11    := andl @s3_11, 0x33333333
  s4_12    := andl @s3_12, 0x33333333
  
  s4_13    := andl @s3_13, 0x33333333
  s4_14    := andl @s3_14, 0x33333333
  s4_15    := andl @s3_15, 0x33333333
  s4_16    := andl @s3_16, 0x33333333  
 
  s5_1     := slrl @s3_1,  2
  s5_2     := slrl @s3_2,  2
  s5_3     := slrl @s3_3,  2
  s5_4     := slrl @s3_4,  2
  
  s5_5     := slrl @s3_5,  2
  s5_6     := slrl @s3_6,  2
  s5_7     := slrl @s3_7,  2
  s5_8     := slrl @s3_8,  2
  
  s5_9     := slrl @s3_9,  2
  s5_10    := slrl @s3_10, 2
  s5_11    := slrl @s3_11, 2
  s5_12    := slrl @s3_12, 2
  
  s5_13    := slrl @s3_13, 2
  s5_14    := slrl @s3_14, 2
  s5_15    := slrl @s3_15, 2
  s5_16    := slrl @s3_16, 2
  
  s6_1     := andl @s5_1,  0x33333333
  s6_2     := andl @s5_2,  0x33333333
  s6_3     := andl @s5_3,  0x33333333
  s6_4     := andl @s5_4,  0x33333333
  
  s6_5     := andl @s5_5,  0x33333333
  s6_6     := andl @s5_6,  0x33333333
  s6_7     := andl @s5_7,  0x33333333
  s6_8     := andl @s5_8,  0x33333333
  
  s6_9     := andl @s5_9,  0x33333333
  s6_10    := andl @s5_10, 0x33333333
  s6_11    := andl @s5_11, 0x33333333
  s6_12    := andl @s5_12, 0x33333333
  
  s6_13    := andl @s5_13, 0x33333333
  s6_14    := andl @s5_14, 0x33333333
  s6_15    := andl @s5_15, 0x33333333
  s6_16    := andl @s5_16, 0x33333333 
  
  s7_1     := addl @s4_1,  @s6_1
  s7_2     := addl @s4_2,  @s6_2
  s7_3     := addl @s4_3,  @s6_3
  s7_4     := addl @s4_4,  @s6_4
  
  s7_5     := addl @s4_5,  @s6_5
  s7_6     := addl @s4_6,  @s6_6
  s7_7     := addl @s4_7,  @s6_7
  s7_8     := addl @s4_8,  @s6_8
  
  s7_9     := addl @s4_9,  @s6_9
  s7_10    := addl @s4_10, @s6_10
  s7_11    := addl @s4_11, @s6_11
  s7_12    := addl @s4_12, @s6_12
  
  s7_13    := addl @s4_13, @s6_13
  s7_14    := addl @s4_14, @s6_14
  s7_15    := addl @s4_15, @s6_15
  s7_16    := addl @s4_16, @s6_16
  
  s8_1     := slrl @s7_1,  4
  s8_2     := slrl @s7_2,  4
  s8_3     := slrl @s7_3,  4
  s8_4     := slrl @s7_4,  4
  
  s8_5     := slrl @s7_5,  4
  s8_6     := slrl @s7_6,  4
  s8_7     := slrl @s7_7,  4
  s8_8     := slrl @s7_8,  4
  
  s8_9     := slrl @s7_9,  4
  s8_10    := slrl @s7_10, 4
  s8_11    := slrl @s7_11, 4
  s8_12    := slrl @s7_12, 4
  
  s8_13    := slrl @s7_13, 4
  s8_14    := slrl @s7_14, 4
  s8_15    := slrl @s7_15, 4
  s8_16    := slrl @s7_16, 4
  
  s9_1     := addl @s7_1,  @s8_1
  s9_2     := addl @s7_2,  @s8_2
  s9_3     := addl @s7_3,  @s8_3
  s9_4     := addl @s7_4,  @s8_4
  
  s9_5     := addl @s7_5,  @s8_5
  s9_6     := addl @s7_6,  @s8_6
  s9_7     := addl @s7_7,  @s8_7
  s9_8     := addl @s7_8,  @s8_8
  
  s9_9     := addl @s7_9,  @s8_9
  s9_10    := addl @s7_10, @s8_10
  s9_11    := addl @s7_11, @s8_11
  s9_12    := addl @s7_12, @s8_12
  
  s9_13    := addl @s7_13, @s8_13
  s9_14    := addl @s7_14, @s8_14
  s9_15    := addl @s7_15, @s8_15
  s9_16    := addl @s7_16, @s8_16
  
  s10_1    := andl @s9_1,  0xF0F0F0F
  s10_2    := andl @s9_2,  0xF0F0F0F
  s10_3    := andl @s9_3,  0xF0F0F0F
  s10_4    := andl @s9_4,  0xF0F0F0F
  
  s10_5    := andl @s9_5,  0xF0F0F0F
  s10_6    := andl @s9_6,  0xF0F0F0F
  s10_7    := andl @s9_7,  0xF0F0F0F
  s10_8    := andl @s9_8,  0xF0F0F0F
  
  s10_9    := andl @s9_9,  0xF0F0F0F
  s10_10   := andl @s9_10, 0xF0F0F0F
  s10_11   := andl @s9_11, 0xF0F0F0F
  s10_12   := andl @s9_12, 0xF0F0F0F
 
  s10_13   := andl @s9_13, 0xF0F0F0F
  s10_14   := andl @s9_14, 0xF0F0F0F
  s10_15   := andl @s9_15, 0xF0F0F0F
  s10_16   := andl @s9_16, 0xF0F0F0F
 
  s11_1    := mull @s10_1,  0x1010101
  s11_2    := mull @s10_2,  0x1010101
  s11_3    := mull @s10_3,  0x1010101
  s11_4    := mull @s10_4,  0x1010101
  
  s11_5    := mull @s10_5,  0x1010101
  s11_6    := mull @s10_6,  0x1010101
  s11_7    := mull @s10_7,  0x1010101
  s11_8    := mull @s10_8,  0x1010101
  
  s11_9    := mull @s10_9,  0x1010101
  s11_10   := mull @s10_10, 0x1010101
  s11_11   := mull @s10_11, 0x1010101
  s11_12   := mull @s10_12, 0x1010101
  
  s11_13   := mull @s10_13, 0x1010101
  s11_14   := mull @s10_14, 0x1010101
  s11_15   := mull @s10_15, 0x1010101
  s11_16   := mull @s10_16, 0x1010101
  
  s12_1    := slrl @s11_1,  24
  s12_2    := slrl @s11_2,  24
  s12_3    := slrl @s11_3,  24
  s12_4    := slrl @s11_4,  24
  
  s12_5    := slrl @s11_5,  24  
  s12_6    := slrl @s11_6,  24
  s12_7    := slrl @s11_7,  24
  s12_8    := slrl @s11_8,  24
  
  s12_9    := slrl @s11_9,  24
  s12_10   := slrl @s11_10, 24
  s12_11   := slrl @s11_11, 24
  s12_12   := slrl @s11_12, 24
  
  s12_13   := slrl @s11_13, 24
  s12_14   := slrl @s11_14, 24
  s12_15   := slrl @s11_15, 24
  s12_16   := slrl @s11_16, 24
  
              wrl @s12_1,  result_buffer + 0
              wrl @s12_2,  result_buffer + 1
              wrl @s12_3,  result_buffer + 2
              wrl @s12_4,  result_buffer + 3
             
              wrl @s12_5,  result_buffer + 4
              wrl @s12_6,  result_buffer + 5
              wrl @s12_7,  result_buffer + 6
              wrl @s12_8,  result_buffer + 7
              
              wrl @s12_9,  result_buffer + 8
              wrl @s12_10, result_buffer + 9
              wrl @s12_11, result_buffer + 10
              wrl @s12_12, result_buffer + 11
              
              wrl @s12_13, result_buffer + 12
              wrl @s12_14, result_buffer + 13
              wrl @s12_15, result_buffer + 14
              wrl @s12_16, result_buffer + 15

              jmp check_counter_mem
complete

check_counter_reg:
  getl #result
  addl @1, #itr_result
  setl #result, @1
  setl #counter, #counter + 16
  ;getl 1024
  getl 256
  subl @1, #counter
  je  @1, stop_timer
  jne @2, new_popcnt512_reg
complete

check_counter_mem:
  ; r1       := rdl result_buffer + 0
  ; r2       := rdl result_buffer + 1
  ; r3       := rdl result_buffer + 2
  ; r4       := rdl result_buffer + 3
  
  ; r5       := rdl result_buffer + 4
  ; r6       := rdl result_buffer + 5
  ; r7       := rdl result_buffer + 6
  ; r8       := rdl result_buffer + 7
 
  ; r9       := rdl result_buffer + 8
  ; r10      := rdl result_buffer + 9
  ; r11      := rdl result_buffer + 10
  ; r12      := rdl result_buffer + 11
  
  ; r13      := rdl result_buffer + 12
  ; r14      := rdl result_buffer + 13
  ; r15      := rdl result_buffer + 14
  ; r16      := rdl result_buffer + 15
  
  ; s1       := addl @r1,  [result_buffer + 16]
  ; s2       := addl @r2,  [result_buffer + 17]
  ; s3       := addl @r3,  [result_buffer + 18]
  ; s4       := addl @r4,  [result_buffer + 19]
  
  ; s5       := addl @r5,  [result_buffer + 20]
  ; s6       := addl @r6,  [result_buffer + 21]
  ; s7       := addl @r7,  [result_buffer + 22]
  ; s8       := addl @r8,  [result_buffer + 23]
 
  ; s9       := addl @r9,  [result_buffer + 24]
  ; s10      := addl @r10, [result_buffer + 25]
  ; s11      := addl @r11, [result_buffer + 26]
  ; s12      := addl @r12, [result_buffer + 27]
  
  ; s13      := addl @r13, [result_buffer + 28]
  ; s14      := addl @r14, [result_buffer + 29]
  ; s15      := addl @r15, [result_buffer + 30]
  ; s16      := addl @r16, [result_buffer + 31]
  
              ; wrl @s1,  result_buffer + 16
              ; wrl @s2,  result_buffer + 17
              ; wrl @s3,  result_buffer + 18
              ; wrl @s4,  result_buffer + 19
              
              ; wrl @s5,  result_buffer + 20
              ; wrl @s6,  result_buffer + 21
              ; wrl @s7,  result_buffer + 22
              ; wrl @s8,  result_buffer + 23
              
              ; wrl @s9,  result_buffer + 24
              ; wrl @s10, result_buffer + 25
              ; wrl @s11, result_buffer + 26
              ; wrl @s12, result_buffer + 27
              
              ; wrl @s13, result_buffer + 28
              ; wrl @s14, result_buffer + 29
              ; wrl @s15, result_buffer + 30
              ; wrl @s16, result_buffer + 31
  
  
              setl #counter, #counter + 1
              ;getl 1024
              getl 1
              subl @1, #counter
              je  @1, stop_timer
              jne @2, new_popcnt512_mem
complete

stop_timer:
  jmp save_result
  getl #ST0VAL
  wrl @1, 0x40000
complete

save_result:
  jmp stop
  getl #result
  wrl @1, 0x40004
complete

stop:
  getl 0x0
complete

