;Constant list
.include "HDL50001_pcf.inc"

.alias UART_DATA    UART3_DATA
.alias UART_BDR     UART3_BDR
.alias UART_ST      UART3_ST
.alias UART_CR      UART3_CR

.alias UART_PORT_PIN  0x300
.alias UART_PORT_BPS  GPIOD_BPS

.data

.align    8

 SummPOPCNT:    //  POPCNT  
    .long \
                0, 0, 0, 0

 .align    8

 popCountOfByte256:
    .byte \
           0, 1, 1, 2, 1, 2, 2, 3, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           5, 6, 6, 7, 6, 7, 7, 8

.text

//====================================
    .alias StartTimer.time_value_start 0x0FFFFFFFF
    .alias StartTimer.PSCPERIOD 0x00000001
    .alias StartTimer.Iteration_COUNT 1
    .alias StartTimer.Iteration_STEP 1

//====================================

    ;   
    .alias UseGPR3 1
    .alias UseSummPOPCNT 0
//====================================


//====================================

start:
    getl 0xFFFFFFFF
    wrl @1, TIM0_CNT ;
    getl 0x00000001
    wrl @1, TIM0_PSCPER ; 
    getl 0
    wrl @1, SummPOPCNT
    wrl @2, SummPOPCNT + 4
    wrl @3, SummPOPCNT + 8
    wrl @4, SummPOPCNT + 12
    jmp timer_start
complete

timer_start:
    getl 0x00000005
    wrl @1, TIM0_CR
    jmp Get_start_time
complete

Get_start_time:

                rdl    TIM0_CNTVAL
                setl    #1, @1

                jmp    code_begin

complete

//====================================

code_begin:
    ;   StartTimer.Iteration_COUNT  StartTimer.Iteration_STEP

 r1 :=          getl    StartTimer.Iteration_COUNT
                setq    #2, @r1

                jmp    code_loop

complete

//====================================

code_loop:

 r1 :=          getl    #2
 r2 :=          subl    @r1, StartTimer.Iteration_STEP
 r3 :=          setl    #2, @r2

                je    @r1, Get_finish_time    //    
                jne    @r1, code_main

complete

//====================================

//  32  Inline mc_POPCNT32_v3
code_main:

                ;  
                ;jmp    code_loop
                jmp Get_finish_time
                
tbl :=          getl popCountOfByte256

                ;   
 a1 :=          getl    #2            //rdl    mc_PopCnt32.ARG1
 a2 :=          subl    @1, 1
 a3 :=          subl    @2, 2
 a4 :=          subl    @3, 3
                
 s1 :=          slrl    @a1, 8
 s2 :=          slrl    @a1, 16
 s3 :=          slrl    @a1, 24
 s4 :=          slrl    @a2, 8
 s5 :=          slrl    @a2, 16
 s6 :=          slrl    @a2, 24
 s7 :=          slrl    @a3, 8
 s8 :=          slrl    @a3, 16
 s9 :=          slrl    @a3, 24
 s10 :=         slrl    @a4, 8
 s11 :=         slrl    @a4, 16
 s12 :=         slrl    @a4, 24

 l1 :=          and    @a1, 0xFF
 l2 :=          and    @s1, 0xFF
 l3 :=          and    @s2, 0xFF
 l4 :=          and    @s3, 0xFF
 l5 :=          and    @a2, 0xFF
 l6 :=          and    @s4, 0xFF
 l7 :=          and    @s5, 0xFF
 l8 :=          and    @s6, 0xFF
 l9 :=          and    @a3, 0xFF
 l10 :=         and    @s7, 0xFF
 l11 :=         and    @s8, 0xFF
 l12 :=         and    @s9, 0xFF
 l13 :=         and    @a4, 0xFF
 l14 :=         and    @s10, 0xFF
 l15 :=         and    @s11, 0xFF
 l16 :=         and    @s12, 0xFF

 ad1 :=         addl    @l1, @tbl
 ad2 :=         addl    @l2, @tbl
 ad3 :=         addl    @l3, @tbl
 ad4 :=         addl    @l4, @tbl
 ad5 :=         addl    @l5, @tbl
 ad6 :=         addl    @l6, @tbl
 ad7 :=         addl    @l7, @tbl
 ad8 :=         addl    @l8, @tbl
 ad9 :=         addl    @l9, @tbl
 ad10 :=        addl    @l10, @tbl
 ad11 :=        addl    @l11, @tbl
 ad12 :=        addl    @l12, @tbl
 ad13 :=        addl    @l13, @tbl
 ad14 :=        addl    @l14, @tbl
 ad15 :=        addl    @l15, @tbl
 ad16 :=        addl    @l16, @tbl

 rd1 :=         rdb    @ad1
 rd2 :=         rdb    @ad2
 rd3 :=         rdb    @ad3
 rd4 :=         rdb    @ad4
 rd5 :=         rdb    @ad5
 rd6 :=         rdb    @ad6
 rd7 :=         rdb    @ad7
 rd8 :=         rdb    @ad8
 rd9 :=         rdb    @ad9
 rd10 :=        rdb    @ad10
 rd11 :=        rdb    @ad11
 rd12 :=        rdb    @ad12
 rd13 :=        rdb    @ad13
 rd14 :=        rdb    @ad14
 rd15 :=        rdb    @ad15
 rd16 :=        rdb    @ad16


 ; reg3 :=        getl #3
 ; reg4 :=        getl #4
 ; reg5 :=        getl #5
 ; reg6 :=        getl #6
 
 reg3 :=        rdl SummPOPCNT
 reg4 :=        rdl SummPOPCNT + 4
 reg5 :=        rdl SummPOPCNT + 8
 reg6 :=        rdl SummPOPCNT + 12
 
 it1 :=         addl    @rd1, @rd2
 it2 :=         addl    @rd3, @rd4
 it3 :=         addl    @it1, @it2
 it4 :=         addl    @rd5, @rd6
 it5 :=         addl    @rd7, @rd8
 it6 :=         addl    @it4, @it5
 it7 :=         addl    @rd9, @rd10
 it8 :=         addl    @rd11, @rd12
 it9 :=         addl    @it7, @it8
 it10 :=        addl    @rd13, @rd14
 it11 :=        addl    @rd15, @rd16
 it12 :=        addl    @it10, @it11

//   
 r1 :=          addl    @reg3, @it3
 r2 :=          addl    @reg4, @it6
 r3 :=          addl    @reg5, @it9
 r4 :=          addl    @reg6, @it12

                ; 
                ; setl    #3, @r1
                ; setl    #4, @r2
                ; setl    #5, @r3
                ; setl    #6, @r4

            wrl @r1, SummPOPCNT
            wrl @r2, SummPOPCNT + 4
            wrl @r3, SummPOPCNT + 8
            wrl @r2, SummPOPCNT + 12

complete

//====================================

Get_finish_time:

 r1 :=          rdl    TIM0_CNTVAL
 r2 :=          getl    #1
 r3 :=          subl    @r2, @r1
 r4 :=          slll    @r3, 1

                setl    #3, @r4    ;   

                getl    0x0
                wrl    @1, TIM0_CR    ;  
                jmp     initUART

complete

//====================================

initUART:
    getl 0x00000300
    wrl @1, UART_PORT_BPS
    getl 0x00000104
    wrl @1, UART_BDR
    getl 0x00000003
    wrl @1, UART_CR
    jmp send_byte_UART
    setl #2, 7
 complete

send_byte_UART:
    getl #2
    jne @1, send_byte_UART
    je @2, buf_TXD
    getq #3
    slrq @1, 8
    setq #3, @1
    wrl @3, UART_DATA
    subl @7, 1
    setl #2, @1
 complete

buf_TXD:
    rdl UART_ST
    getl 0x00000004
    and @1, @2
    je @1, buf_TXD
    jne @2, end
complete

end:
    getl 0x1000
complete

