;Constant list
.include "HDL50001_pcf.inc"

.alias UART_DATA    UART3_DATA
.alias UART_BDR     UART3_BDR
.alias UART_ST      UART3_ST
.alias UART_CR      UART3_CR

.alias UART_PORT_PIN  0x300
.alias UART_PORT_BPS  GPIOD_BPS

.data

.align    8

 SummPOPCNT:    //  POPCNT  
    .long \
                0

 .align    8

 popCountOfByte256:
    .byte \
           0, 1, 1, 2, 1, 2, 2, 3, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           1, 2, 2, 3, 2, 3, 3, 4, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           2, 3, 3, 4, 3, 4, 4, 5, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           3, 4, 4, 5, 4, 5, 5, 6, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           4, 5, 5, 6, 5, 6, 6, 7, \
           5, 6, 6, 7, 6, 7, 7, 8

.text

//====================================
    .alias StartTimer.time_value_start 0x0FFFFFFFF
    .alias StartTimer.PSCPERIOD 0x00000001
    .alias StartTimer.Iteration_COUNT 1
    .alias StartTimer.Iteration_STEP 1

//====================================

    ;   
    .alias UseGPR3 1
    .alias UseSummPOPCNT 0
//====================================


//====================================

start:
    getl 0xFFFFFFFF
    wrl @1, TIM0_CNT ;
    getl 0x00000001
    wrl @1, TIM0_PSC ; 
    setl #2, 0
    setl #3, 0
    jmp timer_start
complete

timer_start:
    getl 0x00000005
    wrl @1, TIM0_CR
    jmp Get_start_time
complete

Get_start_time:

                rdl    TIM0_CNTVAL
                setl    #1, @1

                jmp    code_begin

complete

//====================================

code_begin:
    ;   StartTimer.Iteration_COUNT  StartTimer.Iteration_STEP

 r1 :=          getl    StartTimer.Iteration_COUNT
                setq    #2, @r1

                jmp    code_loop

complete

//====================================

code_loop:

 r1 :=          getl    #2
 r2 :=          subl    @r1, StartTimer.Iteration_STEP
 r3 :=          setl    #2, @r2

                je    @r1, Get_finish_time    //    
                jne    @r1, code_main

complete

//====================================

//  32  Inline mc_POPCNT32_v3
code_main:

                ;  
                jmp    code_loop

                ;   
 a1 :=          getl    #2            //rdl    mc_PopCnt32.ARG1
               
 l1 :=          slrl    @a1, 8
 l2 :=          slrl    @a1, 16
 l3 :=          slrl    @a1, 24

 l4 :=          and    @a1, 0xFF

 l5 :=          and    @l1, 0xFF
 l6 :=          and    @l2, 0xFF
 l7 :=          and    @l3, 0xFF

 l8 :=          addl    @l4, popCountOfByte256
 l9 :=          addl    @l5, popCountOfByte256
 l10 :=         addl    @l6, popCountOfByte256
 l11 :=         addl    @l7, popCountOfByte256

 l12 :=         rdb    @l8
 l13 :=         rdb    @l9
 l14 :=         rdb    @l10
 l15 :=         rdb    @l11

 l16 :=         addl    @l12, @l13
 l17 :=         addl    @l14, @l15

 l18 :=         addl    @l16, @l17

; //   
 ; r2 :=          getl    #3
 ; r4 :=          addl    @r2, @l18

                ; ; 
                ; setl    #3, @r4


//   
 r2 :=          rdl    SummPOPCNT
 r4 :=          addl    @r2, @l18

               wrl    @r4, SummPOPCNT


complete

//====================================

Get_finish_time:

 r1 :=          rdl    TIM0_CNTVAL
 r2 :=          getl    #1
 r3 :=          subl    @r2, @r1
 r4 :=          slll    @r3, 0x1

                setl    #3, @r4    ;   

                getl    0x0
                wrl    @1, TIM0_CR    ;  

                jmp    initUART

complete

//====================================

initUART:
    getl 0x00000300
    wrl @1, UART_PORT_BPS
    getl 0x00000104
    wrl @1, UART_BDR
    getl 0x00000003
    wrl @1, UART_CR
    jmp send_byte_UART
    setl #2, 7
 complete

send_byte_UART:
    getl #2
    jne @1, send_byte_UART
    je @2, buf_TXD
    getq #3
    slrq @1, 8
    setq #3, @1
    wrl @3, UART_DATA
    subl @7, 1
    setl #2, @1
 complete

buf_TXD:
    rdl UART_ST
    getl 0x00000004
    and @1, @2
    je @1, buf_TXD
    jne @2, end
complete

end:
    getl 0x1000
complete

